/* This file is part of the db4o object database http://www.db4o.com

Copyright (C) 2004 - 2011  Versant Corporation http://www.versant.com

db4o is free software; you can redistribute it and/or modify it under
the terms of version 3 of the GNU General Public License as published
by the Free Software Foundation.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see http://www.gnu.org/licenses/. */
package com.db4o.db4ounit.common.assorted;


import com.db4o.*;
import com.db4o.db4ounit.common.api.*;
import com.db4o.ext.*;

import db4ounit.*;


public class PreventMultipleOpenTestCase extends Db4oTestWithTempFile {

	public static void main(String[] args) {
		new ConsoleTestRunner(PreventMultipleOpenTestCase.class).run();
	}

	public void testOpenTwice(){
		ObjectContainer oc = openFile();
		Assert.expect(DatabaseFileLockedException.class, new CodeBlock() {
			public void run() throws Throwable {
				openFile();
			}
		});
		oc.close();
	}
	
	public void testReopen(){
		ObjectContainer oc = openFile();
		oc.close();
		oc = openFile();
		Assert.isNotNull(oc);
		oc.close();
	}

	private ObjectContainer openFile() {
		return Db4oEmbedded.openFile(newConfiguration(), tempFile());
	}
}